package libchord.rmi;

import java.math.BigInteger;
import java.rmi.Remote;
import java.rmi.RemoteException;
import java.util.LinkedList;

import libchord.Identifier;

public interface RemoteNode extends Remote {


	public abstract void notify(Identifier nodeID) throws RemoteException;

	
	// Functions to query the overlay network
	public abstract Identifier findSuccessor(BigInteger key) throws RemoteException;
	public abstract Identifier closestPrecedingNode(BigInteger key) throws RemoteException;
	
	// Functions to query/set the node
	public abstract Identifier getIdentifier() throws RemoteException;
	public abstract Identifier getSuccessor() throws RemoteException;
	public abstract LinkedList<Identifier> getSuccessors() throws RemoteException;
	public abstract Identifier getPredecessor() throws RemoteException;
	
	// Support functions
	public boolean ping() throws RemoteException;
	

}
