package libchord.utils;

import java.math.BigInteger;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

public abstract class Utils {
	public static String hashAlgorithm = "SHA-1";
	
	public static BigInteger sha1Hash(String msg) {
		try {
			MessageDigest cypher = MessageDigest.getInstance(hashAlgorithm);
			byte[] digest = cypher.digest(msg.getBytes());
			return new BigInteger(1, digest);
		} catch (NoSuchAlgorithmException e) {
			System.err.println(hashAlgorithm + " not found???");
			e.printStackTrace();
			return null;
		}
	}

	public static int getHashSize() {
		try {
			//20 per SHA-1
			return MessageDigest.getInstance(hashAlgorithm).getDigestLength();
		} catch (NoSuchAlgorithmException e) {
			System.err.println(hashAlgorithm + " not found???");
			e.printStackTrace();
			return -1;
		}
	}
}
